import os
from opencensus.ext.azure.log_exporter import AzureLogHandler
from azure.storage.blob import BlobServiceClient

def connect_azure_monitor(logger):
    try:
        instrumentation_key = os.getenv("Instrumentation_Key")
        logger.addHandler(AzureLogHandler(connection_string=f"InstrumentationKey={instrumentation_key}"))
        return logger
    except Exception as ex:
        raise ex


def get_azure_sa_client(account_name, account_key):
    try:
        connection_string = f"DefaultEndpointsProtocol=https;AccountName={account_name};AccountKey={account_key};EndpointSuffix=core.windows.net"
        blob_service_client = BlobServiceClient.from_connection_string(connection_string)
        return blob_service_client
    except Exception as ex:
        raise ex
