from libs import sa, files as f1
from datetime import datetime
from os import path
import io
import json
import logging


def configura_logger(nombreProceso):
    logger = logging.getLogger(f"{nombreProceso}")
    logger.setLevel(logging.INFO)
    logger_file_name = f"log/{nombreProceso}-{int(datetime.now().timestamp())}.log"
    handler = logging.FileHandler(f"{logger_file_name}")
    formatter = logging.Formatter('%(asctime)s - %(name)s - %(levelname)s - %(message)s')
    handler.setFormatter(formatter)
    logger.addHandler(handler)
    return logger, logger_file_name


def obtener_ruta_log(config):
    remotepath = f1.obtener_ruta(
        config,
        "storage_paths",
        "log",
        f"la ruta remota para log es obligatoria.",
    )
    return remotepath


def escribe_log_storage(config, filePath, periodo):
    fileName = path.basename(filePath)
    remotePath = obtener_ruta_log(config)
    nombre_remoto = path.join(remotePath, fileName)
    if periodo:
       nombre_remoto = nombre_remoto.replace("[PERIODO]", periodo)
    else:
       nombre_remoto = nombre_remoto.replace("periodo/[PERIODO]", "general")
    sa.escribe_sa(config, filePath, nombre_remoto)
