from libs import params_lib as pl, config_lib as cl, files as f1, log_lib as log
import smtplib
import os
from email.mime.text import MIMEText
from email.mime.multipart import MIMEMultipart


def notifica_error(config, periodo, proceso, host_ip):
    estado = "failed"
    ruta_log = log.obtener_ruta_remoto(config, periodo)
    envia_notificacion(config, periodo, estado, proceso, ruta_log, host_ip)


def notifica_exito(config, periodo, proceso, host_ip):
    estado = "success"
    envia_notificacion(config, periodo, estado, proceso, "", host_ip)


def envia_notificacion(config, periodo, estado, proceso, ruta_log, host_ip):
    print(f"Envio de notificacion: {proceso}")
    raiz = "notificacion"
    subject = f1.obtener_ruta2(
        config,
        raiz,
        estado,
        "subject",
        f"El parámetro subject del esatdo {estado} es obligatorio para la notificacion."
    )
    TO = f1.obtener_ruta2(
        config,
        raiz,
        estado,
        "to",
        f"El parámetro TO del esatdo {estado} es obligatorio para la notificacion."
    )
    CC = f1.obtener_ruta2(
        config,
        raiz,
        estado,
        "cc",
        f"El parámetro CC del esatdo {estado} es obligatorio para la notificacion."
    )
    message = f1.obtener_ruta2(
        config,
        raiz,
        estado,
        "message",
        f"El parámetro message del esatdo {estado} es obligatorio para la notificacion."
    )
    subject = subject.replace("[PERIODO]", periodo)
    subject = subject.replace("[PROCESO]", proceso)
    message = message.replace("[PERIODO]", periodo)
    message = message.replace("[PROCESO]", proceso)
    message = message.replace("[RUTA_ARCHIVO_LOG]", ruta_log)

    envio_correo_smtp(config, subject, TO, CC, message, host_ip)


def envia_notificacion_accuracy(config, periodo, estado, proceso, ruta_log_acc, accion, host_ip):
    print(f"Envio de notificacion: {proceso}")
    raiz = "notificacion"
    subject = f1.obtener_ruta2(
        config,
        raiz,
        estado,
        "subject",
        f"El parámetro subject del esatdo {estado} es obligatorio para la notificacion."
    )
    TO = f1.obtener_ruta2(
        config,
        raiz,
        estado,
        "to",
        f"El parámetro TO del esatdo {estado} es obligatorio para la notificacion."
    )
    CC = f1.obtener_ruta2(
        config,
        raiz,
        estado,
        "cc",
        f"El parámetro CC del esatdo {estado} es obligatorio para la notificacion."
    )
    message = f1.obtener_ruta2(
        config,
        raiz,
        estado,
        "message",
        f"El parámetro message del esatdo {estado} es obligatorio para la notificacion."
    )
    subject = subject.replace("[PERIODO]", periodo)
    subject = subject.replace("[PROCESO]", proceso)
    message = message.replace("[PERIODO]", periodo)
    message = message.replace("[PROCESO]", proceso)
    message = message.replace("[RUTA_ARCHIVO_LOG]", ruta_log_acc)
    message = message.replace("[DESCRIPCION_ACCION]", accion)

    envio_correo_smtp(config, subject, TO, CC, message, host_ip)


def envio_correo_smtp(config, subject, TO, CC, message, host_ip):
    serverMail = pl.validar_parametros(
        cl.valor_config(config, "smtp", "server"),
        "El parámetro server del servidor por SMTP es obligatorio."
    )
    port = pl.validar_parametros(
        cl.valor_config(config, "smtp", "port"),
        "El parámetro port del servidor por SMTP es obligatorio."
    )
    sender = pl.validar_parametros(
        cl.valor_config(config, "smtp", "sender"),
        "El parámetro sender del servidor por SMTP es obligatorio."
    )

    proxy = cl.valor_config(config, "smtp", "proxy")

#    proxy = pl.validar_parametros(
#        cl.valor_config(config, "smtp", "proxy"),
#        "El parámetro proxy del servidor por SMTP es obligatorio."
#    )

    authentication = pl.validar_parametros(
        cl.valor_config(config, "smtp", "authentication"),
        "El parámetro authentication del servidor por SMTP es obligatorio."
    )
    if authentication:
        keysender = pl.validar_parametros(
            cl.valor_config(config, "smtp", "keysender"),
            "El parámetro keysender del servidor por SMTP es obligatorio."
        )
    else:
        keysender = ""
    envio_correo(
        serverMail,
        port,
        sender,
        proxy,
        authentication,
        keysender,
        subject,
        TO,
        CC,
        message,
        host_ip)


def envio_correo(
    serverOfMail,
    portOfMail,
    senderOfThisMail,
    proxyServer,
    authentication,
    keyForMail,
    subjectOfMail,
    recipients,
    ccInMail,
    mailMessage,
    host_ip
    ):
    try:
        if proxyServer:
            os.environ["HTTPS_PROXY"] = proxyServer
        messageTemplate = MIMEMultipart('alternative')
        messageTemplate.set_charset('utf8')
        messageTemplate["FROM"] = senderOfThisMail
        messageTemplate["Subject"] = subjectOfMail
        messageTemplate["To"] = recipients
        messageTemplate["CC"] = ccInMail
        formattedMailMessage = MIMEText(mailMessage.encode('utf-8'), 'plain', 'UTF-8')
        messageTemplate.attach(formattedMailMessage)
        server = smtplib.SMTP(serverOfMail, portOfMail)
        server.ehlo(f"{host_ip}")
        #server.starttls()
        if authentication:
            server.login(senderOfThisMail, keyForMail)
        server.sendmail(
            senderOfThisMail,
            ", ".join([recipients, ccInMail]),
            messageTemplate.as_string())
        server.quit()
        if proxyServer:
            del os.environ['HTTPS_PROXY']
    except Exception as err:
        raise err
