import cx_Oracle


def makedsn(host, port, sid):
    return f"(DESCRIPTION=(ADDRESS=(PROTOCOL=TCP)(HOST={host})(PORT={port}))(CONNECT_DATA=(SERVER = DEDICATED)(SERVICE_NAME={sid})))"


def connexion(host, port, sid, userName, password):
    try:
        dsn = makedsn(host, port, sid) #cx_Oracle.makedsn(host, port, sid)
        connection = cx_Oracle.connect(userName, password, dsn)
    except Exception as e:
        raise (e)
    return connection


def select_table(host, port, sid, userName, password, sql_select):
    try:
        connection = connexion(host, port, sid, userName, password)
        cursor = connection.cursor()
        cursor.execute(sql_select)
        rows = cursor.fetchall()
        col_name = [row[0] for row in cursor.description]
        cursor.close()
        connection.close()
    except Exception as e:
        raise (e)
    return rows, col_name


def insert_table(userName, password, host, port, sid, sql, tup_insert):
    try:
        connection = connexion(host, port, sid, userName, password)
        cursor = connection.cursor()
        for i in range(len(tup_insert)):
            tupla = tup_insert[i]
            cursor.executemany(sql, tupla)
            connection.commit()
        cursor.close()
        connection.close()
    except Exception as e:
        raise (e)


def execute_sql(userName, password, host, port, sid, sql):
    try:
        connection = connexion(host, port, sid, userName, password)
        cursor = connection.cursor()
        cursor.execute(sql)
        connection.commit()
        cursor.close()
        connection.close()
    except Exception as e:
        raise (e)


def execute_sp(userName, password, host, port, sid, spName, params):
    try:
        connection = connexion(host, port, sid, userName, password)
        cursor = connection.cursor()
        if len(params) == 0:
          cursor.callproc(spName)
        else:
          cursor.callproc(spName, params)
        cursor.close()
        connection.close()
    except Exception as e:
        raise (e)
