from libs import s3 as s3l, params_lib as pl, config_lib as cl, files as fl
from datetime import datetime as dt
from dateutil.relativedelta import relativedelta


def obtiene_periodo_raw(config):
    print("Obtiene periodo de raw que sirve para comparar la data a validar.")
    referencepath = fl.obtener_ruta(
        config,
        "s3paths",
        "raw",
        "la ruta remota para la data de raw es obligatoria.")
    positionFileList = fl.obtener_ruta2(
        config,
        "valida-input",
        "positionfiles",
        "raw",
        "la posicion remota para la lista de archivos de raw es obligatoria.")

    positionFileList = int(positionFileList)
    if positionFileList <= 0:
        raise Exception(f"la posicion remota (positionfiles) del archivo de configuración debe ser mayor a cero.")
    else:
        positionFileList = positionFileList - 1
    listDirectories = s3l.lista_subdirectorios(config, referencepath)
    if len(listDirectories) > 0:
        listDirectories.sort(reverse=True)
        periodo = str(listDirectories[positionFileList])
    else:
        periodo = ""
    return periodo


def obtiene_periodo_accuracy(config):
    print("Obtiene periodo accuracy.")
    numeroPeriodo = pl.validar_parametros(
        cl.valor_config(config, "retrain", "periodoDatos"),
        "El número de periodos de datos (periodoDatos) a obtener es obligatorio."
    )
    fechaactual = dt.now() + relativedelta(months=numeroPeriodo)
    periodo = fechaactual.strftime("%Y%m")
    return periodo


def obtiene_periodo_ejecucion():
    print("Obtiene periodo de ejecucion.")
    fechaactual = dt.now()
    periodo = fechaactual.strftime("%Y%m")
    return periodo


def obtener_periodo_pred(config, periodoEjecutado):
    cantMesesPeriodoPred = pl.validar_parametros(
        cl.valor_config(
            config,
            "salida",
            "process",
            "nro_meses_periodo_pred"),
        "La cantidad de meses a adicionar para el periodo pred no puede ser nulo.",
    )
    periodo_pred = cantMesesPeriodoPred
    periodo_pred = dt.strptime(periodoEjecutado, "%Y%m") + relativedelta(months=cantMesesPeriodoPred)
    periodo_pred = periodo_pred.strftime("%Y%m")
    return periodo_pred
