from libs import sa_lib as sal, config_lib as cl, params_lib as pl


def lee_sa(config, localpath, referencepath):
    prm_azr_accountName = pl.validar_parametros(
        cl.valor_config(config, "storage_access", "azr_sa_accountName"),
        "El parametro account name es obligatorio."
    )
    prm_azr_accountKey = pl.validar_parametros(
        cl.valor_config(config, "storage_access", "azr_sa_accountKey"),
        "El parametro account key es obligatorio."
    )
    prm_azr_sa_bucket = pl.validar_parametros(
        cl.valor_config(config, "storage_access", "azr_sa_bucket"),
        "El parametro bucket es obligatorio."
    )
    return sal.readSA(prm_azr_accountName,
                      prm_azr_accountKey,
                      prm_azr_sa_bucket,
                      localpath,
                      referencepath)


def escribe_sa(config, localpath, referencepath):
    prm_azr_accountName = pl.validar_parametros(
        cl.valor_config(config, "storage_access", "azr_sa_accountName"),
        "El parametro account name es obligatorio."
    )
    prm_azr_accountKey = pl.validar_parametros(
        cl.valor_config(config, "storage_access", "azr_sa_accountKey"),
        "El parametro account key es obligatorio."
    )
    prm_azr_sa_bucket = pl.validar_parametros(
        cl.valor_config(config, "storage_access", "azr_sa_bucket"),
        "El parametro bucket es obligatorio."
    )
    sal.uploadSA(prm_azr_accountName,
                 prm_azr_accountKey,
                 prm_azr_sa_bucket,
                 localpath,
                 referencepath)


def existe_archivo(config, referencepath):
    prm_azr_accountName = pl.validar_parametros(
        cl.valor_config(config, "storage_access", "azr_sa_accountName"),
        "El parametro account name es obligatorio."
    )
    prm_azr_accountKey = pl.validar_parametros(
        cl.valor_config(config, "storage_access", "azr_sa_accountKey"),
        "El parametro account key es obligatorio."
    )
    prm_azr_sa_bucket = pl.validar_parametros(
        cl.valor_config(config, "storage_access", "azr_sa_bucket"),
        "El parametro bucket es obligatorio."
    )
    existe = sal.find(prm_azr_accountName,
                      prm_azr_accountKey,
                      prm_azr_sa_bucket,
                      referencepath)
    return existe


def lista_subdirectorios(config, referencepath):
    prm_azr_accountName = pl.validar_parametros(
        cl.valor_config(config, "storage_aaccess", "azr_sa_accountName"),
        "El parametro account name es obligatorio."
    )
    prm_azr_accountKey = pl.validar_parametros(
        cl.valor_config(config, "storage_access", "azr_sa_accountKey"),
        "El parametro account key es obligatorio."
    )
    prm_azr_sa_bucket = pl.validar_parametros(
        cl.valor_config(config, "storage_access", "azr_sa_bucket"),
        "El parametro bucket es obligatorio."
    )
    listDirectories = sal.listSubDirectoriesSA(prm_azr_accountName,
                                               prm_azr_accountKey,
                                               prm_azr_sa_bucket,
                                               referencepath)
    return listDirectories
