import os
from os import path
from libs import azure as az


def readSA(prm_azr_accountName, prm_azr_accountKey, prm_azr_sa_bucket, localpath, referencepath):
    try:
        blob_service_client = az.get_azure_sa_client(prm_azr_accountName, prm_azr_accountKey)
        blob_client = blob_service_client.get_blob_client(container=prm_azr_sa_bucket, blob=referencepath)
        file = path.basename(localpath)

        with open(localpath, 'wb') as data:
            data.write(blob_client.download_blob().readall())

        return file
    except Exception as ex:
        raise ex


def uploadSA(prm_azr_accountName, prm_azr_accountKey, prm_azr_sa_bucket, localpath, referencepath):
    try:
        blob_service_client = az.get_azure_sa_client(prm_azr_accountName, prm_azr_accountKey)
        blob_client = blob_service_client.get_blob_client(container=prm_azr_sa_bucket, blob=referencepath)
        file = path.basename(localpath)

        with open(localpath, 'rb') as data:
            blob_client.upload_blob(data, overwrite=True)

        return file
    except Exception as ex:
        raise ex


def listSubDirectoriesSA(prm_azr_accountName, prm_azr_accountKey, prm_azr_sa_bucket, prefixname):
    try:
        blob_service_client = az.get_azure_sa_client(prm_azr_accountName, prm_azr_accountKey)
        container_client = blob_service_client.get_container_client(prm_azr_sa_bucket)
        blobs = container_client.list_blobs(name_starts_with=prefixname, delimiter="/")

        list=[]
        for blob in blobs:
            list.append(blob.name)

        return list
    except Exception as ex:
        raise ex


def listFilesSA(prm_azr_accountName, prm_azr_accountKey, prm_azr_sa_bucket, prefixname):
    try:
        blob_service_client = az.get_azure_sa_client(prm_azr_accountName, prm_azr_accountKey)
        container_client = blob_service_client.get_container_client(prm_azr_sa_bucket)
        blobs = container_client.list_blobs(name_starts_with=prefixname)

        list=[]
        for blob in blobs:
            if not blob.name.endswith('/'):
                list.append(blob.name)

        return list
    except Exception as ex:
        raise ex


def find(prm_azr_accountName, prm_azr_accountKey, prm_azr_sa_bucket, filename):
    try:
        blob_service_client = az.get_azure_sa_client(prm_azr_accountName, prm_azr_accountKey)
        container_client = blob_service_client.get_container_client(prm_azr_sa_bucket)
        blob_client = container_client.get_blob_client(filename)

        if blob_client.exists():
            return True
        else:
            return False
    except Exception as ex:
        raise ex
